[![Build Status](http://cc-jenkins-ci.westus2.cloudapp.azure.com/job/clear-containers-shim-azure-ubuntu-16-04/badge/icon)](http://cc-jenkins-ci.westus2.cloudapp.azure.com/job/clear-containers-shim-azure-ubuntu-16-04/)
[![Build Status](http://cc-jenkins-ci.westus2.cloudapp.azure.com/job/clear-containers-shim-azure-ubuntu-17-04/badge/icon)](http://cc-jenkins-ci.westus2.cloudapp.azure.com/job/clear-containers-shim-azure-ubuntu-17-04/)
[![Build Status](https://travis-ci.org/clearcontainers/shim.svg?branch=master)](https://travis-ci.org/clearcontainers/shim)
[![Coverity](https://scan.coverity.com/projects/12134/badge.svg)](https://scan.coverity.com/projects/clearcontainers-shim)

# `cc-shim`

`cc-shim` is a process spawned by the runtime per container workload. The runtime 
provides the pid of the cc-shim process to containerd-shim on OCI create command.

Usage:
   cc-shim --container-id $(container_id) --token $(token) --uri $(uri)

$(uri) is the proxy connection uri passed to the shim (by the runtime). 
Supported schemes are unix:// and tcp://. The shim uses this to open a unix 
socket/tcp connection with the proxy.
 
$(token) is a connection token generated by the proxy while connecting to the
runtime.

The shim communicates with the proxy using the protocol defined in the [package API documents]( https://godoc.org/github.com/clearcontainers/proxy/api).

`cc-shim` forwards all signals to the cc-proxy process to be handled by the agent
in the VM.

The shim forwards any input received from containerd-shim to cc-proxy and 
writes any stream data received from the proxy to its stdout/stderr streams.
